﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Threading;

namespace GridRepro
{
    class GridViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private ObservableCollection<GridRowViewModel> _gridRows;
        private GridRowViewModel _selectedGridRow;

        public GridViewModel()
        {
            _gridRows = new ObservableCollection<GridRowViewModel>();

            DispatcherTimer dispatcherTimer = new DispatcherTimer();
            dispatcherTimer.Tick += new EventHandler(dispatcherTimer_Tick);
            dispatcherTimer.Interval = new TimeSpan(0, 0, 4);
            dispatcherTimer.Start();
        }

        public ObservableCollection<GridRowViewModel> GridRows
        {
            get { return _gridRows; }
        }

        public GridRowViewModel SelectedGridRow
        {
            get { return _selectedGridRow; }
            set
            {
                if (_selectedGridRow == value) return;

                _selectedGridRow = value;

                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("SelectedGridRow"));
                }
            }
        }

        private void  dispatcherTimer_Tick(object sender, EventArgs e)
        {
            var newRow = new GridRowViewModel() { Name = Guid.NewGuid().ToString() };

 	        GridRows.Add(newRow);
            
            SelectedGridRow = newRow;
        }
    }
}
